/* Programmer :- Bindesh Kumar Singh
   Date :-		 21 November, 2006 (Happy Diwali)
   Last update :- 2 May, 2007
*/
#define UNICODE
#include <windows.h>
#include "resource.h" 
#define ID_TIMER 1000
#define TIMEOUT 200

BOOL dlgcwtproc(HWND, UINT, WPARAM, LPARAM);
VOID CALLBACK timerproc(HWND,UINT,UINT,DWORD);
VOID CALLBACK fiocomproutine(DWORD dwErrorCode, DWORD dwNumberOfBytesTransfered, LPOVERLAPPED lpOverlapped);
void whaterror();

HANDLE hdir,hdirmon,iocomport;
TCHAR target[MAX_PATH+1], *error = (TCHAR*)TEXT("Error"); 
int chk = 0,flag = 0; 
DWORD dwwait,compkey,bytesdone;
HDC hdcdlg; HICON hico[2]; 
HINSTANCE happ;
RECT rect;
FILE_NOTIFY_INFORMATION *fni;
OVERLAPPED overlap,*lpoverlap;
CHAR buff[4096];

int __stdcall WinMain(HINSTANCE hinst, HINSTANCE hprevinst, LPSTR lpcmdline, int nshowcmd)
{
	happ = hinst;
	lpoverlap = (OVERLAPPED*)&overlap;
	if( -1 == DialogBox(hinst,MAKEINTRESOURCE(IDD_DIALOG1),NULL,(DLGPROC)dlgcwtproc))
    {
        MessageBox(0,TEXT("Can't create interface"),error,0);
        whaterror();
        return 0L;
    }
	return 0;
}

BOOL dlgcwtproc(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
	
	switch(msg)
	{
	case WM_INITDIALOG:
		SetWindowPos(hdlg,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOOWNERZORDER);
        hdcdlg = GetDC(hdlg);
        hico[0] = LoadIcon(happ,MAKEINTRESOURCE(IDI_RED));
		hico[1] = LoadIcon(happ,MAKEINTRESOURCE(IDI_GREEN));
		GetWindowRect((HWND)GetDlgItem(hdlg,IDC_STATICRECT_STATUS),&rect);
        return TRUE;
    
    case WM_MOVE: case WM_SIZE:
         GetWindowRect((HWND)GetDlgItem(hdlg,IDC_STATICRECT_STATUS),&rect);
         return TRUE;
         
	case WM_COMMAND:
		switch(LOWORD(wparam))
		{
		case IDC_B_MONITOR:
			GetDlgItemText(hdlg,IDC_EDIT_DIRNAME,target,sizeof(target));
			if(lstrcmp(target,TEXT("")))
			{ 
                hdir = CreateFile(target,FILE_LIST_DIRECTORY,FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE,NULL,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS|FILE_FLAG_OVERLAPPED,NULL); 				
                if(hdir == INVALID_HANDLE_VALUE)
			    {
                    whaterror();
				    return TRUE;
                }
				hdirmon = FindFirstChangeNotification(target,TRUE,FILE_NOTIFY_CHANGE_FILE_NAME
						|FILE_NOTIFY_CHANGE_DIR_NAME|FILE_NOTIFY_CHANGE_ATTRIBUTES
						|FILE_NOTIFY_CHANGE_SIZE|FILE_NOTIFY_CHANGE_SECURITY);
                if(hdirmon == INVALID_HANDLE_VALUE)
                {
                    whaterror();
                    return TRUE;
                }
                iocomport = CreateIoCompletionPort(hdir,iocomport,(DWORD)buff,0);
                if(!iocomport)
				{
                    whaterror();
                  	return TRUE;
                }
				GetWindowRect((HWND)GetDlgItem(hdlg,IDC_STATICRECT_STATUS),&rect);
			    DrawIcon(hdcdlg,rect.bottom - rect.top,rect.right - rect.left + 45,hico[1]);
                chk = flag = 1;
                SetTimer(hdlg,ID_TIMER,TIMEOUT,(TIMERPROC)timerproc);
                return TRUE;
			}
			MessageBox(hdlg,TEXT("Please enter target directory name"),error,0);
			return TRUE;

		case IDC_B_STOP:
			if(chk)
			{
			   FindCloseChangeNotification(hdirmon);
			   chk = flag = 0;
			   KillTimer(hdlg,ID_TIMER);
            }
			DrawIcon(hdcdlg,rect.bottom - rect.top,rect.right - rect.left + 45,hico[1]);
			PlaySound(0,0,SND_PURGE);
			return TRUE;

		case IDC_B_EXIT:
			EndDialog(hdlg,0);
			KillTimer(hdlg,ID_TIMER);
			return TRUE;
		}
	}
	return FALSE;
}

void CALLBACK timerproc(HWND hwnd,UINT tmsg,UINT idtimer,DWORD dwtime)
{                      
   dwwait =  WaitForSingleObject(hdirmon,0);
   switch (dwwait) 
   { 
	case WAIT_OBJECT_0: 
					PlaySound(TEXT("alert.wav"),0,SND_FILENAME | SND_ASYNC);
					DrawIcon(hdcdlg,rect.bottom - rect.top,rect.right - rect.left + 45,hico[0]);
					if( FindNextChangeNotification(hdirmon) == FALSE )
                         ExitProcess(GetLastError()); 
				    ZeroMemory(&fni,sizeof(fni));
/* __________________________________________________________________________________ */
if(ReadDirectoryChangesW(hdir,buff,sizeof(buff),TRUE,FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME
    | FILE_NOTIFY_CHANGE_ATTRIBUTES	| FILE_NOTIFY_CHANGE_SIZE | FILE_NOTIFY_CHANGE_SECURITY | FILE_NOTIFY_CHANGE_LAST_WRITE | FILE_NOTIFY_CHANGE_LAST_ACCESS
    | FILE_NOTIFY_CHANGE_CREATION, &bytesdone, &overlap, NULL) )
            {
                     fni = (PFILE_NOTIFY_INFORMATION) buff;
                     if(!flag)
                         return;
                         
                     switch(fni->Action)
                     {
                     case FILE_ACTION_ADDED:
                          MessageBox(hwnd,TEXT("File added"),TEXT(""),0);
                          break;
                          
                     case FILE_ACTION_REMOVED:
                          MessageBox(hwnd,TEXT("File deleted"),TEXT(""),0);
                          break;
                          
                     case FILE_ACTION_MODIFIED:
                          MessageBox(hwnd,TEXT("File modified"),TEXT(""),0);
                          break;
                               
                     case FILE_ACTION_RENAMED_OLD_NAME:
			         case FILE_ACTION_RENAMED_NEW_NAME:
                          MessageBox(hwnd,TEXT("File renamed"),TEXT(""),0);
                          break;
                     }
                     flag = 0;
            }
else
     whaterror();
/* __________________________________________________________________________________ */
     chk = 0;
     break; 
 
	 case WAIT_TIMEOUT:  
       break;
                   
     default:
       DrawIcon(hdcdlg,rect.bottom - rect.top,rect.right - rect.left + 45,hico[1]);
        		
     }
        		
}

VOID CALLBACK fiocomproutine(DWORD dwErrorCode, DWORD dwNumberOfBytesTransfered, LPOVERLAPPED lpOverlapped)
{
  if(! dwErrorCode)
       return;
      
}

void whaterror()
{ 
	LPVOID lpvbuf;
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | /* LocalAlloc used and saves pointer in 5 argument.*/
    FORMAT_MESSAGE_FROM_SYSTEM,NULL,GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
    (LPTSTR)&lpvbuf,0,NULL);
	MessageBox(NULL,(LPCTSTR)lpvbuf,TEXT("INFORMATION"), MB_OK | MB_ICONINFORMATION );
	LocalFree(lpvbuf);
}
